/*组件说明

socket.emit('add_purchase_order', data)//新增采购订单,data为订单信息

*/

<style scoped>
/* 组件样式 */

/* 横屏样式 */
@media only screen and (orientation: landscape) {
    
    
    
}

/* 竖屏样式 */
@media only screen and (orientation: portrait) {
    
    
    
}

</style>



<!-- pickup-component.vue -->
<template><div>



  <div class="edit_card shadow">



        <!-- 合同title -->
        <div style="background:#cceeff;position:absolute;left:2vmin;top:2vmin;right:2vmin;height:20%;border-radius:2vmin;">
            <h1 style="padding:0; margin:0; display: inline-block;">新建采购合同</h1>
            <input style="font-size:1.5em; display: inline-block; margin-left: 10px;" placeholder="合同ID" v-model="data.order_id" />
            <input style="font-size:1.5em; display: inline-block; margin-left: 10px;" placeholder="分类项" v-model="data.class" />
        </div>



        <!-- 双方信息 -->
        <div  style="position:absolute;left:2vmin;right:2vmin;top:calc(20% + 4vmin);height:30%;">
          <!-- 卖方卡片 -->
          <div class="card">
            <div class="card-inner" :class="{ flipped: sellerFlipped }">
              <div class="card-face card-front" @click.self="toggleFlip('seller')">
                <h2 style="margin: 0;">卖方</h2>
              </div>
              <div class="card-face card-back" @click.self="toggleFlip('seller')">
                <h2 style="margin: 0;">卖方</h2>
                <div class="input-group">
                  <input placeholder="公司" v-model="data.seller_company" />
                  <input placeholder="库区" v-model="data.store" />
                </div>
                <div class="input-group">
                  <input placeholder="买方联系人" v-model="data.seller_contact" />
                  <input placeholder="买方电话" v-model="data.seller_phone" />
                </div>
              </div>
            </div>
          </div>
            
          <!-- 买方卡片 -->
          <div class="card" style="right:0;">
            <div class="card-inner" :class="{ flipped: buyerFlipped }">
              <div class="card-face card-front" @click.self="toggleFlip('buyer')">
                <h2 style="margin: 0;">买方</h2>
                    <input id="buyer_company" placeholder="卖方公司名称" style="width:97%;" v-model="data.buyer_company" />
                <div class="input-group">
                  <input placeholder="买方联系人" v-model="data.buyer_contact" />
                  <input placeholder="买方电话" v-model="data.buyer_phone" />
                </div>
                <div class="input-group">
                  <input placeholder="开户银行" v-model="data.bank_name" />
                  <input placeholder="银行账号" v-model="data.bank_id" />
                </div>
              </div>
              <div class="card-face card-back" @click.self="toggleFlip('buyer')">
                <h2 style="margin: 0;">买方详细信息</h2>
              </div>
            </div>
          </div>
        </div>



        <!-- 合同信息 -->
        <div style="position:absolute;left:2vmin;right:2vmin;bottom:2vmin;top:calc(50% + 6vmin); border-radius:2vmin; background: #cceeff;">
          <div style="display: flex; justify-content: space-between; align-items: center; margin-bottom: 10px; font-size: 24px;">
            <div style="display: flex; align-items: center; width: 40%;">
              <input style="flex-grow: 1; padding: 8px; border: 2px solid #ccc; border-radius: 4px; font-size: 24px;" placeholder="单价" v-model="data.price" />
              <p style="margin: 0; padding-right: 10px;">元/吨</p>
            </div>
            <div style="display: flex; align-items: center; width: 40%;">
              <input style="flex-grow: 1; padding: 8px; border: 2px solid #ccc; border-radius: 4px; font-size: 24px;" placeholder="数量" v-model="data.quantity" />
              <p style="margin: 0; padding-right: 10px;">吨</p>
            </div>
          </div>
    
          <div style="display: flex; justify-content: space-between; align-items: center;">
            <div style="display: flex; align-items: center; width: 48%;">
              <input style="width: 30%; padding: 8px; border: 1px solid #ccc; border-radius: 4px; margin-right: 10px;font-size:24px;" placeholder="全款天数" v-model="data.pay_day" />
              <h2 style="font-size: 20px; margin: 0;">{{data.pay_deadline}}</h2>
            </div>
            <div style="display: flex; align-items: center; width: 48%;">
              <input style="width: 30%; padding: 8px; border: 1px solid #ccc; border-radius: 4px; margin-right: 10px;font-size:24px;" placeholder="提货天数" v-model="data.pickup_day" />
              <h2 style="font-size: 20px; margin: 0;">{{data.pickup_deadline}}</h2>
            </div>
          </div>
        </div>

    <button @click="add_order_back" class="edit_button_center" style="right:12vh;background:gray;">取消</button>
    <button @click="add_purchase_order_confirm" class="edit_button_center" style="right:2vh;background:green;">确定</button>
  </div>



</div></template>




<script setup>
import { ref, reactive, inject, nextTick, onMounted, defineExpose } from 'vue';

const p_c = inject('p_c')

const OneStep = inject('OneStep');


const data = reactive({
    buyer_company:'',
})




var sellerFlipped = ref(false)
var buyerFlipped = ref(false)



data.pay_deadline = computed(() => {
  return new Date(Math.min(new Date('2024-07-09').getTime() + (data.pay_day > 1 ? data.pay_day - 1 : 0) * 24 * 60 * 60 * 1000, 8640000000000000)).toISOString().split('T')[0]
});

data.pickup_deadline = computed(() => {
  return new Date(Math.min(new Date('2024-07-09').getTime() + (data.pickup_day > 1 ? data.pickup_day - 1 : 0) * 24 * 60 * 60 * 1000, 8640000000000000)).toISOString().split('T')[0]
});

function toggleFlip(side) {
  if (side === 'seller') {
    sellerFlipped.value = !sellerFlipped.value;
  } else if (side === 'buyer') {
    buyerFlipped.value = !buyerFlipped.value;
  }
}






function add_order_back() {
    p_c.add_purchase_order_card_show = false;
    console.log(JSON.stringify(data));
}

function add_purchase_order_confirm() {
    console.log('存入服务器数据库');
    console.log(data);
    socket.emit('add_purchase_order', data)
    p_c.add_purchase_order_card_show = false;
}








</script>




<style scoped>

input {
  width: 40%;
  height: 40px;
}

.shadow {
  box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1), 
              0 6px 20px rgba(0, 0, 0, 0.1), 
              0 8px 40px rgba(0, 0, 0, 0.2);
}

.card-container {
  display: flex;
  width: 100%;
  
  background: white;
  padding: 20px;
  box-sizing: border-box;
  overflow: visible;
}

.card {
    position: absolute;
    width: calc(50% - 1vmin);
    height: 100%;
    border-radius: 2vmin;
    cursor: pointer;perspective: 1000px;
}

.card-inner {
  width: 100%;
  height: 100%;
  position: relative;
  transform-style: preserve-3d;
  transition: transform 0.6s;
}

.card-inner.flipped {
  transform: rotateY(180deg);
}

.card-face {
  position: absolute;
  width: 100%;
  height: 100%;
  backface-visibility: hidden;
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  padding: 20px;
  box-sizing: border-box;
  border-radius: 2vmin;
  box-shadow: 0 4px 8px rgba(0,0,0,0.1);
}

.card-front {
  background-color: #ffcccc;
  background-color: #cceeff;
}

.card-back {
  background-color: #cceeff;
  transform: rotateY(180deg);
}

.input-group {
  display: flex;
  width: 100%;
  overflow: hidden;
}

.input-group input {
  box-sizing: border-box;
  width: 50%;
  border: 1px solid #ccc;
  margin: 0;
  padding: 5px;
}

.edit_card {
  position: fixed;
  left: 50%;
  top: 50%;
  transform: translate(-50%,-50%);
  width: 80vh;
  height: 50vh;
  z-index: 9999999;
  background: white;
  border-radius: 4vmin;
  padding: 4vh;
}

.edit_button_center {
  position: absolute;
  bottom: 2vh;
  width: 8vh;
  height: 4vh;
  border: 0;
  border-radius: 2vh;
}
</style>